## ros-foxy-osrf-testing-tools-cpp 1.3.4

=== src/memory_tools/CMakeLists.txt ===
# Integrate backward-cpp according to:
#   https://github.com/bombela/backward-cpp/tree/v1.5#modifying-cmake_module_path

# Note, I had to use Backward_DIR since they provide a config file rather than a module...
# list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/vendor/bombela/backward-cpp")
set(Backward_DIR "${CMAKE_CURRENT_SOURCE_DIR}/vendor/bombela/backward-cpp")
set(FPHSA_NAME_MISMATCHED TRUE)
find_package(Backward REQUIRED)
unset(FPHSA_NAME_MISMATCHED)

add_library(memory_tools SHARED
  custom_memory_functions.cpp
  implementation_monitoring_override.cpp
  initialize.cpp
  is_working.cpp
  memory_tools_service.cpp
  monitoring.cpp
  register_hooks.cpp
  stack_trace.cpp
  testing_helpers.cpp
  verbosity.cpp
)

target_include_directories(memory_tools
  PUBLIC
    $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>
)
target_link_libraries(memory_tools PRIVATE Backward::Backward)

find_library(DL_LIBRARY NAMES dl)

if(UNIX AND NOT APPLE)
  # On Linux like systems, add dl and use the normal library and LD_PRELOAD.

  if(DL_LIBRARY)
    target_link_libraries(memory_tools PUBLIC ${DL_LIBRARY})
  endif()
endif()

target_compile_definitions(memory_tools
  PRIVATE "OSRF_TESTING_TOOLS_CPP_MEMORY_TOOLS_BUILDING_DLL")

add_library(memory_tools_interpose SHARED
  memory_tools.cpp
)
target_link_libraries(memory_tools_interpose memory_tools)

option(OSRF_TESTING_TOOLS_CPP_DISABLE_MEMORY_TOOLS
  "Disable environment configuration for memory tools"
  OFF)

# Memory tools doesn't work on Windows right now.
# TODO(wjwwood): If on aarch64, so not set the preload environment variables, until fixed.
# see: https://github.com/osrf/osrf_testing_tools_cpp/issues/3
if(WIN32 OR CMAKE_SYSTEM_PROCESSOR STREQUAL "aarch64")
  set(OSRF_TESTING_TOOLS_CPP_DISABLE_MEMORY_TOOLS ON)
endif()

if (NOT OSRF_TESTING_TOOLS_CPP_DISABLE_MEMORY_TOOLS)
  set(memory_tools_is_available TRUE)
  if(APPLE)
    list(APPEND memory_tools_extra_test_env
      DYLD_INSERT_LIBRARIES=$<TARGET_FILE:memory_tools_interpose>)
  elseif(UNIX)
    list(APPEND memory_tools_extra_test_env
      LD_PRELOAD=$<TARGET_FILE:memory_tools_interpose>)
  endif()
endif()

install(TARGETS memory_tools
  EXPORT memory_tools
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin)

install(EXPORT memory_tools
  DESTINATION share/${PROJECT_NAME}/cmake
  NAMESPACE "${PROJECT_NAME}::"
  FILE "memory_toolsExport.cmake"
)

install(TARGETS memory_tools_interpose
  EXPORT memory_tools_interpose
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin)

install(EXPORT memory_tools_interpose
  DESTINATION share/${PROJECT_NAME}/cmake
  NAMESPACE "${PROJECT_NAME}::"
  FILE "memory_tools_interposeExport.cmake"
)

set(memory_tools_extra_test_env "${memory_tools_extra_test_env}" PARENT_SCOPE)
set(memory_tools_is_available "${memory_tools_is_available}" PARENT_SCOPE)
set(memory_tools_src_dir_internal_testing_only
  "$<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src>" PARENT_SCOPE)

=== debian/changelog ===
ros-foxy-osrf-testing-tools-cpp (1.3.4-1focal) focal; urgency=high

  * Update cmake minimum version to 2.8.12 (#61 <https://github.com/osrf/osrf_testing_tools_cpp/issues/61>) (#63 <https://github.com/osrf/osrf_testing_tools_cpp/issues/63>)
  * Contributors: Louise Poubel, Stephen Brawner

 -- William Woodall <william@osrfoundation.org>  Tue, 31 Aug 2021 07:00:00 -0000

ros-foxy-osrf-testing-tools-cpp (1.3.3-1focal) focal; urgency=high

  * Workarounds for Android (#52 <https://github.com/osrf/osrf_testing_tools_cpp/issues/52>) (#59 <https://github.com/osrf/osrf_testing_tools_cpp/issues/59>)
  * Fix execinfo.h not found for QNX (#50 <https://github.com/osrf/osrf_testing_tools_cpp/issues/50>) (#57 <https://github.com/osrf/osrf_testing_tools_cpp/issues/57>)
  * Contributors: Esteve Fernandez, Ahmed Sobhy

 -- William Woodall <william@osrfoundation.org>  Mon, 07 Dec 2020 08:00:00 -0000

ros-foxy-osrf-testing-tools-cpp (1.3.2-1focal) focal; urgency=high

  * Suppressed a FPHSA CMake warning in Backward (#48 <https://github.com/osrf/osrf_testing_tools_cpp/issues/48>)
  * Contributors: Dirk Thomas

 -- William Woodall <william@osrfoundation.org>  Thu, 21 May 2020 07:00:00 -0000

=== debian/control ===
Source: ros-foxy-osrf-testing-tools-cpp
Section: misc
Priority: optional
Maintainer: William Woodall <william@osrfoundation.org>
Build-Depends: debhelper (>= 9.0.0), cmake, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-osrf-testing-tools-cpp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-foxy-ros-workspace
Description: Testing tools for C++, and is used in various OSRF projects.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

# Solve shlibdeps errors in REP136 packages that use GNUInstallDirs:
export DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-osrf-testing-tools-cpp//opt/ros/foxy/lib/:$(CURDIR)/debian/ros-foxy-osrf-testing-tools-cpp//opt/ros/foxy/lib/${DEB_HOST_MULTIARCH}

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
